#include <stdio.h>
#include <ctype.h>
#include <string.h>
#include <assert.h>

#include "parser.h"

#define LIM " \t()"
void
cheapruby(const struct parser_param *param)
{
	FILE *ip;
	char buf[1024], saveline[1024], *token;
	int lineno = 0;
	int next_symbol_is_definition = 0;
	assert(param->size >= sizeof(*param));

	ip = fopen(param->file, "r");
	if (ip == NULL)
		param->die("cannot open file '%s'", param->file);
	while (fgets(buf, sizeof(buf), ip)) {
		char *p, *line = buf;
		int def = 0;

		lineno++;
		buf[strlen(buf)-1] = '\0';			/* 行末の改行文字を削除 */
		strcpy(saveline, buf);				/* 行イメージを保存 */
		for (token = strtok(line, LIM); token != NULL; token = strtok(NULL, LIM)) {
			if (*token == '#')			/* コメント */
				break;
			if (isdigit(*token))			/* 数字 */
				continue;
			if (*token == '\'')			/* リテラル */
				continue;
			if (!strcmp(token, "while") || !strcmp(token, "end"))	/* 予約語 */
				continue;
			if (!strcmp(token, "def")) {		/* 関数定義 */
				next_symbol_is_definition = 1;
				continue;
			}
			if (isalpha(*token)) {			/* シンボル */ 
				param->put(next_symbol_is_definition ? PARSER_DEF : PARSER_REF_SYM, token, lineno, param->file, saveline, param->arg);
				next_symbol_is_definition = 0;
			}
		}
	}
	fclose(ip);
}
